#!/bin/sh
#choix.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}
#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : $$$
#  Author  : jean-louis.sendral@toulouse.iufm.fr
#  Modifier: andre.connes@toulouse.iufm.fr
#  Date    : 24/04/2002
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version
#  @author     Jean- Louis Sendral
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
#
#  *****************************************

#############Prparation du calcul : nom, classe, choix du scnario ou de la squence.

###################"gestion du son
#"global sound
#"if {[catch {package require -exact snack 2.1}]} {
#"    set sound 0
#"} else {
#"    set sound 1
#"}

set basedir [pwd]
# [file dirname $argv0]
cd $basedir
source calculs.conf
source i18n
source path.tcl
set basedir [pwd]
global DOSSIER_EXOS1
##set  DOSSIER_EXOS1 [file join $Home data]
set  DOSSIER_EXOS1 [lindex $argv 0 ]

# #########################################################################
# internationalisation (c) andre.connes@toulouse.iufm.fr
# le fichier i18n, inclus par la commande "source i18n", contient par exemple
#    set i18n(fr,hello) "Bonjour..."
#    set i18n(uk,hello) "Hello..."
# appel   : set message [gettext hello]
# ou bien : puts stdout [gettext hello]
# #########################################################################
#proc gettext { m } {
#  global LG i18n
#  if { [info exists i18n($LG,$m)] } {
#    return $i18n($LG,$m)
#  } elseif { [info exis
#  ts i18n(fr,$m)] } {
#    return $i18n(fr,$m)
#  } else {
#    return "err.i18n_$LG : \"$m\" needed."
#  }
#} ;# proc gettext

#if { [catch {package require Iwidgets}] == 1} {
#tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets #pour que le menu aide fonctionne" -type ok -title "A nous les nombres"
#}

proc showaide {signet} {
catch {
option add *textBackground seashell

set win [iwidgets::hyperhelp .#auto -title "Aide" -modality none -topics {aide}]
    $win showtopic aide#$signet
    $win activate
}
}

bind . <F1> "showaide { }"
global sysFont
source msg.tcl
source fonts.tcl
global scenario
wm geometry . +0+0
wm title . [mc {Choix du scnario}]
## wm resizable . 0 0
. configure  -height 480 -width 640
frame .frame -background #aaaaaa -height 480 -width 360
grid .frame -column 0 -row 0

label .frame.lab_prenom -text [mc {nom}] -background #aaaaaa 
place .frame.lab_prenom -x 130 -y 5
entry .frame.ent_nom -justify center
place .frame.ent_nom -x 80 -y 25
focus .frame.ent_nom
#set nom_elev $tcl_platform(user)
#[exec  id -u -n ]
#.frame.ent_nom insert end $nom_elev
#set nom_elev [.frame.ent_prenom get]
label .frame.lab_classe -text [mc {ta_classe}] -background #aaaaaa
place .frame.lab_classe -x 110 -y 50
entry .frame.ent_classe -justify center
place .frame.ent_classe -x 80  -y 70
#set nom_classe [.frame.ent_classe get]

if { $tcl_platform(platform) == "unix" } {
set nom_elev $tcl_platform(user)
set nom_classe [lindex [exec  id -G -n ] 1]
} else {
 set nom_elev eleve
 set nom_classe classe
}
.frame.ent_nom insert end $nom_elev
.frame.ent_classe insert end  $nom_classe
label .frame.duree_saut -text [mc {duree_max}] -background #aaaaaa
place .frame.duree_saut -x 20 -y 100
entry .frame.ent_duree
place .frame.ent_duree -x 255  -y 95  -width 35
.frame.ent_duree insert end 1000
set duree_saut [.frame.ent_duree get]
checkbutton .frame.unique -variable choix_unique -onvalue u -text [mc {choix_unique}] -background #aaaaaa -anchor e
place .frame.unique -x 5 -y 130

 listbox .frame.list1 -background #c0c0c0 -height 15 -width 20 -yscrollcommand ".frame.scroll1 set"
scrollbar .frame.scroll1 -command ".frame.list1 yview"
place .frame.list1 -x 80 -y 200
place .frame.scroll1 -x 208 -y 200 -height 255
label .frame.menu3 -text [mc {double_clic_choix_sce_seq}]  -background #aaaaaa
place .frame.menu3 -x 10 -y 160
label .frame.scenario -text [mc {sce_seq}] -background #aaaaaa
place .frame.scenario -x 85 -y 180
bind .frame.list1 <Double-ButtonRelease-1> { calc }
#pour lister les scnarios et les squences dj construits.

proc peuplelist1 {}  {
 global DOSSIER_EXOS  basedir choix_lieu DOSSIER_EXOS1  env    Home
  cd  $DOSSIER_EXOS1
set ext .sce ; set ext1 .seq
    .frame.list1 delete 0 end
    catch {foreach i [lsort [glob [file join *$ext]]] {
            .frame.list1 insert end $i ;#"[file rootname $i]
        }
    }
catch {foreach i [lsort [glob [file join *$ext1]]] {
        .frame.list1 insert end $i ;#"[file rootname $i]
    }
}
}
peuplelist1

proc peuplelist2 {} {
global basedir DOSSIER_EXOS1
cd $DOSSIER_EXOS1
    set ext .sce ; set ext1 .seq
    .frame.list1 delete 0 end
    catch {foreach i [lsort [glob [file join *$ext]]] {
            .frame.list1 insert end $i ;#"[file rootname $i]
        }
    }
catch {foreach i [lsort [glob [file join *$ext1]]] {
        .frame.list1 insert end $i ;#"[file rootname $i]
    }
}
cd $basedir
}


#pour lancer le ou les claculs##############

proc calculs {} {
return [.frame.list1 get active]
}

proc  calc {} {
global basedir DOSSIER_EXOS1 choix_lieu   iwish   Home   DOSSIER_EXOS choix_unique
set fich [calculs]
   if  {[file extension $fich] ==".sce" } {
    set liste_sce [list $fich]
} else  {
    cd $DOSSIER_EXOS1
    set f [open [file join $fich] "r"  ]
    set liste_sce [gets $f]
}
foreach exo  $liste_sce {
    if {[file extension [lindex $liste_sce 0]] != ".sce" } {
        set exo "${exo}.sce"
    }
cd  $DOSSIER_EXOS1
#cd "/usr/share/abuledu/applications/abuledu-calculenpluie"
if { $choix_unique == "u" } { 
exec  $iwish  [file join $basedir pluie_un.tcl] [file join $DOSSIER_EXOS1 $exo ] \
[.frame.ent_nom  get] [.frame.ent_classe get] [.frame.ent_duree get]  $DOSSIER_EXOS1
} else {
 exec  $iwish  [file join $basedir pluie.tcl ] [file join $DOSSIER_EXOS1 $exo ] [.frame.ent_nom  get] [.frame.ent_classe get] [.frame.ent_duree  get] $DOSSIER_EXOS1
# destroy .
}
}
} ;#"return [.frame.list1 get active]





